#!/usr/bin/env python
# -*- coding: utf-8 -*-
import serial
import RPi.GPIO as GPIO
import os
import sys
import random
from chatterbotapi import ChatterBotFactory, ChatterBotType
import io
import time
import picamera
from PIL import Image
import zbar

try:
	ser = serial.Serial ("/dev/ttyAMA0")    #Open named port 
	ser.baudrate = 9600                     #Set baud rate to 9600
except:
	print 'Error abriendo el puerto serie'

aux = 0
modocoche = 0
oldmode = 0
velocidad = 25
oldata = 'z'
while True:
	try:
		data = ser.read()                     #Read ten characters from serial port to data
		print data
		if data != oldata or data == 'r' or data == 'l':
			oldata = data
			if data == '*':
				modocoche = 0
				if modocoche == 0 and modocoche != oldmode:
					oldmode = modocoche
					string = '*'
					while data != chr(35):
                                        	data = ser.read()
                                        	string += data
                                	string = string[1:len(string)-1]
                                	oldata = 'z'
                                	print string
					while aux == 0:
						try:
							f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
							f.write('enablePinza\n')
							f.write('1\n')
							f.write('motorPinza\n')
							f.write('80\n')
							f.close()
							os.system('python /home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/evabot.py modovoz')
							aux = 1
						except:
							print 'Ha ocurrido un error abriendo el archivo'
					aux = 0
				else:
					string = '*'
					while data != chr(35):
						data = ser.read()
						string += data
					string = string[1:len(string)-1]
					oldata = 'z'
					print string
					os.system('python /home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/evabot.py %s' % string)				
			else:
				modocoche = 1
			if modocoche == 1 and modocoche != oldmode:
				oldmode = modocoche
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('enablePinza\n')
						f.write('0\n')
						f.write('motorPinza\n')
						f.write('80\n')
						f.close()
						os.system('python /home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/evabot.py modocoche')
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			
			if data == 'F':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('1\n')
						f.write('retrocederDer\n')
                                                f.write('0\n')
						f.write('motorDer\n')
						f.write(str(velocidad))
						f.write('\navanzarIzq\n')
						f.write('1\n')
						f.write('retrocederIzq\n')
                                                f.write('0\n')
						f.write('motorIzq\n')
						f.write(str(velocidad))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'B':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('0\n')
						f.write('retrocederDer\n')
                                                f.write('1\n')
						f.write('motorDer\n')
						f.write(str(velocidad))
						f.write('\navanzarIzq\n')
						f.write('0\n')
						f.write('retrocederIzq\n')
                                                f.write('1\n')
						f.write('motorIzq\n')
						f.write(str(velocidad))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'L':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('1\n')
						f.write('retrocederDer\n')
                                                f.write('0\n')
						f.write('motorDer\n')
						f.write(str(velocidad))
						f.write('\navanzarIzq\n')
						f.write('0\n')
						f.write('retrocederIzq\n')
                                                f.write('1\n')
						f.write('motorIzq\n')
						f.write(str(velocidad))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'R':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('0\n')
						f.write('retrocederDer\n')
                                                f.write('1\n')
						f.write('motorDer\n')
						f.write(str(velocidad))
						f.write('\navanzarIzq\n')
						f.write('1\n')
						f.write('retrocederIzq\n')
                                                f.write('0\n')
						f.write('motorIzq\n')
						f.write(str(velocidad))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'G':            #Delante izq
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('1\n')
						f.write('retrocederDer\n')
                                                f.write('0\n')
						f.write('motorDer\n')
						f.write(str(velocidad))
						f.write('\navanzarIzq\n')
						f.write('1\n')
						f.write('retrocederIzq\n')
                                                f.write('0\n')
						f.write('motorIzq\n')
						f.write(str(velocidad/2))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'I':		#Delante der
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('1\n')
						f.write('retrocederDer\n')
                                                f.write('0\n')
						f.write('motorDer\n')
						f.write(str(velocidad/2))
						f.write('\navanzarIzq\n')
						f.write('1\n')
						f.write('retrocederIzq\n')
                                                f.write('0\n')
						f.write('motorIzq\n')
						f.write(str(velocidad))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'H':		#Atras izq
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('0\n')
						f.write('retrocederDer\n')
                                                f.write('1\n')
						f.write('motorDer\n')
						f.write(str(velocidad))
						f.write('\navanzarIzq\n')
						f.write('0\n')
						f.write('retrocederIzq\n')
                                                f.write('1\n')
						f.write('motorIzq\n')
						f.write(str(velocidad/2))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'J':		#Atras der
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('0\n')
						f.write('retrocederDer\n')
                                                f.write('1\n')
						f.write('motorDer\n')
						f.write(str(velocidad/2))
						f.write('\navanzarIzq\n')
						f.write('0\n')
						f.write('retrocederIzq\n')
                                                f.write('1\n')
						f.write('motorIzq\n')
						f.write(str(velocidad))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'S':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('0\n')
						f.write('retrocederDer\n')
                                                f.write('0\n')
						f.write('motorDer\n')
						f.write(str(0))
						f.write('\navanzarIzq\n')
						f.write('0\n')
						f.write('retrocederIzq\n')
                                                f.write('0\n')
						f.write('motorIzq\n')
						f.write(str(0))
						f.write('\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'W':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('ledsDer\n')
						f.write('1\n')
						f.write('ledsIzq\n')
						f.write('1\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'w':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('ledsDer\n')
						f.write('0\n')
						f.write('ledsIzq\n')
						f.write('0\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'V':
				os.system('omxplayer /home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/horn.wav')
			elif data == 'X':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('controlLeds\n')
						f.write('1,1,1,1,1,1,1\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == 'x':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('controlLeds\n')
						f.write('0,0,0,0,0,0,0\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
			elif data == '0':
				velocidad = 0
			elif data == '1':
				velocidad = 10
			elif data == '2':
				velocidad = 20
			elif data == '3':
				velocidad = 30
			elif data == '4':
				velocidad = 40
			elif data == '5':
				velocidad = 50
			elif data == '6':
				velocidad = 60
			elif data == '7':
				velocidad = 70
			elif data == '8':
				velocidad = 80
			elif data == '9':
				velocidad = 90
			elif data == 'q':
				velocidad = 99
			elif data == 'D':
				while aux == 0:
					try:
						f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
						f.write('avanzarDer\n')
						f.write('0\n')
						f.write('retrocederDer\n')
                                                f.write('0\n')
						f.write('avanzarIzq\n')
						f.write('0\n')
						f.write('retrocederIzq\n')
                                                f.write('0\n')
						f.write('ledsDer\n')
						f.write('0\n')
						f.write('ledsIzq\n')
						f.write('0\n')
						f.write('controlLeds\n')
						f.write('0,0,0,0,0,0,0\n')
						f.close()
						aux = 1
					except:
						print 'Ha ocurrido un error abriendo el archivo'
				aux = 0
		
	except:
		print 'Ha ocurrido un error leyendo el puerto serie'
#ser.write(data)                         #Send back the received data
#ser.close()        

#F = forward
#B = Back
#L - left
#R - right
#G - forward left
#I - forward right
#H - back left
#J - back right
#S - stop
#W - front lights on (luces camara)
#w - front lights off
#U - Back lights on
#u - back lights off
#V - horn on
#v - horn off
#X - Extra on (siete leds)
#x - extra off
#0 - speed 0
#.
#.
#.
#9 - speed 90
#q - maxspeed
#D - stop all
