# -*- coding: utf-8 -*-

import os
import sys
import random
from chatterbotapi import ChatterBotFactory, ChatterBotType
import io
import time
import picamera
from PIL import Image
import zbar
import RPi.GPIO as GPIO
import serial
import signal
import subprocess
import pipes
import wikipedia
import datetime
from pytz import timezone
from translate import Translator

def child(texto):
    os.system('%s' % texto)
    os._exit(0)

def parent(string):
    newpid = os.fork()
    if newpid == 0:
        child(string)
    else:
        time.sleep(10)

def capturarQR():
    # Create the in-memory stream
    stream = io.BytesIO()
    # "Rewind" the stream to the beginning so we can read its content
    os.system('fswebcam -r 640x480 testQr.jpg')
    stream = open('testQr.jpg')
    stream.seek(0)
    pil = Image.open(stream)
    #
    #########################################
    #
    # create a reader
    scanner = zbar.ImageScanner()

    # configure the reader
    scanner.parse_config('enable')

    pil = pil.convert('L')
    width, height = pil.size
    raw = pil.tostring()

    # wrap image data
    image = zbar.Image(width, height, 'Y800', raw)

    # scan the image for barcodes
    scanner.scan(image)
    try:
        # extract results
        for symbol in image:
            print 'decoded', symbol.type, 'symbol', '"%s"' % symbol.data

        del(image)

        return symbol.data
    except:
        return 'Nada'

print 'Antes del texto'
s = ' '.join(sys.argv[1:len(sys.argv)])
print s

translator = Translator(to_lang="es",from_lang="en")
x = datetime.datetime.now(timezone('Europe/Madrid'))

dicdias = {'MONDAY':'Lunes','TUESDAY':'Martes','WEDNESDAY':'Miercoles','THURSDAY':'Jueves', \
'FRIDAY':'Viernes','SATURDAY':'Sabado','SUNDAY':'Domingo'}
dicmes = {'JANUARY':'Enero','FEBRUARY':'Febrero','MARCH':'Marzo','APRIL':'Abril','MAY':'Mayo','JUNE':'Junio', \
          'JULY':'Julio','AUGUST':'Agosto','SEPTEMBER':'Septiembre','OCTOBER':'Octubre','NOVEMBER':'Noviembre','DECEMBER':'Diciembre'}
anho = x.year
mes =  x.month
dia= x.day

fecha = datetime.date(anho, mes, dia)

s = s.decode('UTF-8')
s = s.strip(' \n')
f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/evaia.ia','r')
text = f.read()
f.close()

found = False
respuestas = []
antes = ""
despues = ""
text = text.decode('UTF-8')
text = text.split('\n')
for line in text:
    line = line.split(':')
    if found == True:
        if line[0] == 'R':
            respuestas.append(line[1])
        if line[0] == '-':
            found = False
    if line[0] == 'P':
	#print line[1].strip(' _*')
        if s.find(line[1].strip(' _*').strip()) != -1:
            found = True
            if s.find(line[1].strip(' _*').strip()) > 0:
                antes = s[:s.find(line[1].strip(' _*').strip())-1]
            despues = s[s.find(line[1].strip(' _*').strip())+len(line[1].strip(' _*').strip())+1:]
        else:
            found = False
if len(respuestas) > 1:
    print antes
    print despues
    num = random.randrange(len(respuestas))
    res = respuestas[num-1]
    res = res.strip()
    if res.find('*') != -1:
        res = res[:res.find('*')] + despues
    if res.find('"') != -1:
        res = res.split('"')
        for x in range(0,len(res)):
            if x % 2 == 0:
                f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/comunicacion.log','w')
                f.write(res[x].strip())
                f.close()
            else:
                f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/bot.txt','w')
                f.write(res[x].strip())
                f.close()
                os.system('less bot.txt|iconv -f utf-8 -t iso-8859-1|festival --tts')
    if res[0] == '/':
        res = res.split(',')
        if res[0] == '/wikipedia':
            try:
                wikipedia.set_lang("es")
                res = wikipedia.page(res[1])
                text = res.content
                res = text[:text.find('\n')]
            except:
                res = 'No he encontrado nada en wikipedia relacionado con ' + res[1]
        elif res[0] == '/musica':
            num = random.randrange(11)
            vlc = 'cvlc --play-and-exit "/media/pi/RIPPER/'
            if len(res[1]) > 1:
                vlc += res[1].strip() + '/' + str(num) + '.mp3"'
            else:
                vlc += str(num) + '.mp3"'
            try:
		print vlc
                parent(vlc)
            except:
                res = 'No tengo música de ese tipo, lo siento'
        elif res[0] == '/killmusica':
            os.system('killall vlc')
        elif res[0] == '/apagar':
            os.system('poweroff')
        elif res[0] == '/Qr':
            res = 'La lectura del código Qr es: ' + str(capturarQR())
        elif res[0] == '/detectar':
            face = os.system('python face.py')
            if face == 256:
                res = 'He detectado a alguien delante de mi!'
            else:
                res = 'No encuentro a nadie delante de mí, ¿Estás seguro de que hay alguien?'
        elif res[0] == '/reconocer':
            Qr = capturarQR()
            print Qr
            face = os.system('python face.py')
            if face == 256 and Qr == 'salva':
                res = 'Eres Salvador Moreno Gómez, uno de mis creadores, gracias a ti puedo pensar y actuar en consecuencia!'
            elif face == 256 and Qr == 'antonio':
                res = 'Eres Antonio Molina Cortes, uno de mis creadores, gracias a ti puedo moverme y soy tan guapa!'
            elif face == 256 and Qr == 'enrique':
                res = 'Eres Enrique Norro, a que si? jeje'
            else:
                res = 'No sé quién eres, en un futuro, si te vuelvo a ver, quizás pueda reconocerte.'
        elif res[0] == '/cara':
            f = open('comunicacion.log','w')
            f.write(res[1].strip())
            f.close()
        elif res[0] == '/dia':
            res = "hoy es " + dicdias[fecha.strftime('%A').upper()] + " día " + fecha.strftime('%d').upper() + " de " + dicmes[fecha.strftime('%B').upper()]
        elif res[0] == '/hora':
            if x.strftime('%I')[0] == '0' and x.strftime('%I')[1] != '0':
                res = "Son las " + x.strftime('%I').strip('0') + " horas y " + x.strftime('%M') + " Minutos"
            else:
                res = "Son las " + x.strftime('%I') + " horas y " + x.strftime('%M') + " Minutos"
	elif res[0] == '/traducir':
	    res  = translator.translate(str(res[1]))
else:
    try:
        factory = ChatterBotFactory()
	bot1 = factory.create(ChatterBotType.CLEVERBOT)
	bot1session = bot1.create_session()

	res = bot1session.think(s.encode('UTF-8'));
    except:
        res = 'He perdido mi conectividad a internet, llama a mi técnico, que seguro que es grave.'
	print sys.exc_info()[1] 
print res
print type(res)
if type(res) == unicode or type(res) == str :
    f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/bot.txt','w')
    print res
    try:
        f.write(res.encode('UTF-8'))
    except:
	f.write(res)
    f.close()
    os.system('less /home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/bot.txt|iconv -f utf-8 -t iso-8859-1|festival --tts')
