#!/usr/bin/env python
# -*- coding: utf-8 -*-
import time
import os
import RPi.GPIO as GPIO

#motores 6, ledscamara 2, ledsazules 7, ir 2, bluetooth 2,
#Definicion de pines
motorPinza = 7
motorIzq = 11
motorDer = 12
enablePinza = 38
avanzarDer = 3
avanzarIzq = 13
retrocederDer = 15
retrocederIzq = 19
enableIzq = 36
enableDer = 38
led1 = 22
led2 = 29
led3 = 31
led4 = 32
led5 = 33
led6 = 35
led7 = 37
ledsDer = 18
ledsIzq = 5
#irDer = 13
#irCen = 3
#irIzq = 5
endStop = 16
tx = 8
rx = 10

entradas = [endStop] 
salidas = [motorPinza,motorIzq,motorDer,avanzarDer,avanzarIzq,retrocederDer,retrocederIzq,enablePinza,led1,led2,led3,led4,led5,led6,led7,ledsDer,ledsIzq]

#Configuracion
#try:
#	GPIO.cleanup()
#except:
#	print 'Los GPIO ya estaban limpios'
GPIO.setmode(GPIO.BOARD)
GPIO.setwarnings(False)
GPIO.setup(entradas, GPIO.IN)
GPIO.setup(salidas, GPIO.OUT)

#PWM para los motores
mDer = GPIO.PWM(motorDer,200)
mIzq = GPIO.PWM(motorIzq,200)
mPin = GPIO.PWM(motorPinza,200)
mDer.start(0)
mIzq.start(0)
mPin.start(0)
isup = 1
while True:
	try:
		f = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','r')
		ctrl = 0
		aux = 0
		while ctrl < 20:
			linea = f.readline()
			ctrl +=1
			#Control de la pinza
			if linea == 'motorPinza\n':
				print 'MotorPinza Lectura'
				linea = f.readline()
				linea = linea.split('\n')
				linea = linea[0]
				print linea
				if len(linea) > 1:
					num = (ord(linea[0])-ord('0'))*10+ord(linea[1])-ord('0')
				else:
					num = ord(linea[0])-ord('0')
				#mPin.ChangeDutyCycle(num)
				print 'Pinza Ready!'
				if GPIO.input(endStop) == 0 and isup == 1 and num > 0:
					print 'Motor bajando'
					mPin.ChangeDutyCycle(num)
					while GPIO.input(endStop) != 1:
						mPin.ChangeDutyCycle(num)
					mPin.ChangeDutyCycle(0)
					isup = 0
					num = 0
					time.sleep(2)
					try:
						mPin.ChangeDutyCycle(0)
                                                file = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
                                                file.write('enablePinza\n')
                                                file.write('0\n')
                                                file.write('motorPinza\n')
                                                file.write('0\n')
                                                file.close()
						isup = 0
                                        except:
                                                print 'Error al escribir la cara'
				elif GPIO.input(endStop) == 1 and isup == 0 and num > 0:
					print 'Motor subiendo'
					mPin.ChangeDutyCycle(num)
					while aux == 0:
						try:
							file = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/comunicacion.log','w')
							file.write('Felicidad')
							file.close()
							aux = 1
						except:
							print 'Error escribiendo la cara'
					time.sleep(40)
					isup = 1
					aux = 0
					while aux == 0:
						try:
							file = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/comunicacion.log','w')
							file.write('Normal')
							file.close()
							aux = 1
						except:
							print 'Error escribiendo la cara'
					aux = 0
					try:
						num = 0
						mPin.ChangeDutyCycle(0)
						file = open('/home/pi/Desktop/Granada-Version/BETA-WORKING/Robot/controlGPIO.log','w')
                                        	file.write('enablePinza\n')
                                        	file.write('0\n')
                                        	file.write('motorPinza\n')
                                        	file.write('0\n')
                                        	file.close()
					except:
						print 'Error al escribir la cara'
				#mPin.ChangeDutyCycle(num)
				#elif GPIO.input(endStop) == 0:
				#	GPIO.output(enablePinza,0)
				#elif GPIO.input(endStop) == 1:
				#	while GPIO.input(endStop) == 1:
				#		isup = 0
				#	GPIO.output(enablePinza,0)
				#	os.system('killall mirage')
				
			#Control Motor Izquierdo
			elif linea == 'motorIzq\n':
				print 'MotorIzq lectura'
				linea = f.readline()
				linea = linea.split('\n')
				linea = linea[0]
				print linea
				if len(linea) > 1:
					num = (ord(linea[0])-ord('0'))*10+ord(linea[1])-ord('0')
				else:
					num = ord(linea[0])-ord('0')
				mIzq.ChangeDutyCycle(num)
				print 'MotorIzq Ready!'
				#if num > 50 and GPIO.input(irDer) == 1:
				#	GPIO.output(enableIzq,0)
				#elif GPIO.input(irCen) == 1:
				#	GPIO.output(enableIzq,0)
					
			#Control Motor Derecho
			elif linea == 'motorDer\n':
				print 'MotorDer lectura'
				linea = f.readline()
				linea = linea.split('\n')
				linea = linea[0]
				print linea
				if len(linea) > 1:
					num = (ord(linea[0])-ord('0'))*10+ord(linea[1])-ord('0')
				else:
					num = ord(linea[0])-ord('0')
				mDer.ChangeDutyCycle(num)
				print 'MotorDer Ready!'
				#if num > 50 and GPIO.input(irIzq) == 1:
				#	GPIO.output(enableDer,0)
				#elif GPIO.input(irCen) == 1:
				#	GPIO.output(enableDer,0)
			#Enables para Motores
			elif linea == 'enablePinza\n':
				linea = f.readline()
				linea = linea.split('\n')
				GPIO.output(enablePinza,ord(linea[0])-ord('0'))
			elif linea == 'avanzarIzq\n':
				linea = f.readline()
				linea = linea.split('\n')
				GPIO.output(avanzarIzq,ord(linea[0])-ord('0'))
			elif linea == 'retrocederIzq\n':
                                linea = f.readline()
                                linea = linea.split('\n')
                                GPIO.output(retrocederIzq,ord(linea[0])-ord('0'))
			elif linea == 'avanzarDer\n':
				linea = f.readline()
				linea = linea.split('\n')
				GPIO.output(avanzarDer,ord(linea[0])-ord('0'))
			elif linea == 'retrocederDer\n':
                                linea = f.readline()
                                linea = linea.split('\n')
                                GPIO.output(retrocederDer,ord(linea[0])-ord('0'))
				
			#Control de LEDS
			elif linea == 'ledsDer\n':
				linea = f.readline()
				linea = linea.split('\n')
				GPIO.output(ledsDer,ord(linea[0])-ord('0'))
			elif linea == 'ledsIzq\n':
				linea = f.readline()
				linea = linea.split('\n')
				GPIO.output(ledsIzq,ord(linea[0])-ord('0'))
			elif linea == 'controlLeds\n':
				linea = f.readline()
				linea = linea.split('\n')
				arrayled = linea[0].split(',')
				GPIO.output(led1,ord(arrayled[0])-ord('0'))
				GPIO.output(led2,ord(arrayled[1])-ord('0'))
				GPIO.output(led3,ord(arrayled[2])-ord('0'))
				GPIO.output(led4,ord(arrayled[3])-ord('0'))
				GPIO.output(led5,ord(arrayled[4])-ord('0'))
				GPIO.output(led6,ord(arrayled[5])-ord('0'))
				GPIO.output(led7,ord(arrayled[6])-ord('0'))
		f.close()
		time.sleep(0.2)			
	except:
		print 'Error al abrir el archivo gpio'

