import os
import cv2
import time
import signal
import subprocess
import sys

def detect(path):
    img = cv2.imread(path)
    cascade = cv2.CascadeClassifier("/home/pi/Desktop/Python/haarcascade_frontalface_alt.xml")
    rects = cascade.detectMultiScale(img, 1.3, 4, cv2.cv.CV_HAAR_SCALE_IMAGE, (20,20))

    if len(rects) == 0:
        return [], img
    rects[:, 2:] += rects[:, :2]
    return rects, img

def box(rects, img):
    for x1, y1, x2, y2 in rects:
        cv2.rectangle(img, (x1, y1), (x2, y2), (127, 255, 0), 2)
    cv2.imwrite('/home/pi/Desktop/Robot/detected.jpg', img);


#os.system('fswebcam -r 1280x720 test.jpg')
rects, img = detect("testQr.jpg")
if len(rects) > 0:
    print rects
    sys.exit(1)

#box(rects, img)
